package animation;

import JPlay.Window;
import JPlay.Keyboard;
import JPlay.GameImage;
import JPlay.Sprite;
import JPlay.Animation;
import JPlay.Time;
import JPlay.Collision;
import JPlay.Sound;
import java.awt.Color;
import java.awt.Font;
import javax.swing.JOptionPane;

public class Main {

    public static void main(String[] args) {
        Window janela = new Window(800, 600);

        GameImage fundo = new GameImage("space800x600(2).png");

        GameImage fundo2 = new GameImage("menu.jpg");

        Animation explosao = new Animation("fire blast(2).png", 20);
        explosao.setPosition(-200, -200);

        Sound musica = new Sound("Asimov.wav");

        Sound musica2 = new Sound("Road To Revelation.wav");

        musica2.play();
        musica2.setRepeat(true);

        Keyboard teclado = janela.getKeyboard();

        Font fonte = new Font("Visionaries", Font.TRUETYPE_FONT, 60);

        Font fonte2 = new Font("Showcard Gothic", Font.TRUETYPE_FONT, 24);

        Font fonte3 = new Font("Showcard Gothic", Font.TRUETYPE_FONT, 52);

        Font fonte4 = new Font("Planet Kosmos", Font.TRUETYPE_FONT, 72);

        Font fonte5 = new Font("Excelerate", Font.TRUETYPE_FONT, 24);

        Font fonte6 = new Font("Visionaries", Font.TRUETYPE_FONT, 100);

        Sprite nave = new Sprite("sship1.png", 8);
        nave.x = 400;
        nave.y = 300;

        Sprite nucleo_principal = new Sprite("ball.png", 1);
        nucleo_principal.x = 410;
        nucleo_principal.y = 300;

        Sprite meteoro = new Sprite("Meteor2.gif", 1);
        meteoro.x = 0;
        meteoro.y = 0;

        Sprite meteoro2 = new Sprite("Meteor3.gif", 1);
        meteoro2.x = 801;
        meteoro2.y = 601;

        Sprite meteoro3 = new Sprite("Meteor2.gif", 1);
        meteoro3.x = 801;
        meteoro3.y = -60;

        Sprite meteoro4 = new Sprite("Meteor4.gif", 1);
        meteoro4.x = -60;
        meteoro4.y = 601;

        Sprite meteoro5 = new Sprite("Meteor3.gif", 1);
        meteoro5.x = -80;
        meteoro5.y = -80;

        Sprite meteoro6 = new Sprite("Meteor4.gif", 1);
        meteoro6.x = 801;
        meteoro6.y = 601;

        Sprite nucleo1 = new Sprite("ball (2).png", 1);
        nucleo1.x = meteoro.x + 10;
        nucleo1.y = meteoro.y + 10;

        Sprite nucleo2 = new Sprite("ball (3).png", 1);
        nucleo2.x = meteoro2.x + 18;
        nucleo2.y = meteoro2.y + 18;

        Sprite nucleo3 = new Sprite("ball (2).png", 1);
        nucleo3.x = meteoro3.x + 10;
        nucleo3.y = meteoro3.y + 10;

        Sprite nucleo4 = new Sprite("ball (4).png", 1);
        nucleo4.x = meteoro4.x + 23;
        nucleo4.y = meteoro4.y + 25;

        Sprite nucleo5 = new Sprite("ball (3).png", 1);
        nucleo5.x = meteoro5.x + 18;
        nucleo5.y = meteoro5.y + 18;

        Sprite nucleo6 = new Sprite("ball (4).png", 1);
        nucleo6.x = meteoro6.x + 23;
        nucleo6.y = meteoro6.y + 25;

        boolean colisao;
        boolean menu = true;
        boolean cima = true;
        boolean cima2 = true;
        boolean cima3 = true;
        boolean cima4 = true;
        boolean cima5 = true;
        boolean cima6 = true;
        boolean direita = true;
        boolean direita2 = true;
        boolean direita3 = true;
        boolean direita4 = true;
        boolean direita5 = true;
        boolean direita6 = true;
        boolean gameover = false;
        boolean key_block = false;
        boolean executando = false;

// PARTE REFERENTE A TELA INICIAL ----------------------------------------------

        while ((menu == true) && (executando == false)) {
            fundo2.draw();
            janela.drawText("METEOR STORM", 45, 75, Color.GREEN, fonte4);
            janela.drawText("Press ENTER to start", 50, 550, Color.GREEN, fonte5);
            janela.display();

            if (teclado.keyDown(Keyboard.ENTER_KEY)) {
                musica2.stop();
                menu = false;
                executando = true;
            } else if (teclado.keyDown(Keyboard.ESCAPE_KEY)) {
                janela.exit();
            }

        }

        Time tempo = new Time(250, 70, true);
        tempo.setColor(Color.GREEN);
        tempo.setFont(fonte);

        musica.play();
        musica.setRepeat(true);

// PARTE REFERENTE AOS ELEMENTOS DA TELA ---------------------------------------
        while (executando == true) {

            fundo.draw();

            if (tempo.getTotalSecond() <= 10) {
                janela.drawText("Start warming up with 1...", 230, 580, Color.YELLOW, fonte2);
            } else if ((tempo.getTotalSecond() > 10) && (tempo.getTotalSecond() <= 21)) {
                janela.drawText("You look ready. Let's go with 2, shall we?", 150, 580, Color.YELLOW, fonte2);
            } else if ((tempo.getTotalSecond() > 21) && (tempo.getTotalSecond() <= 27)) {
                janela.drawText("Really good. Maybe it's time for another one...", 120, 580, Color.YELLOW, fonte2);
            } else if ((tempo.getTotalSecond() > 27) && (tempo.getTotalSecond() <= 34)) {
                janela.drawText("Time to get serious, and 3 it is!", 210, 580, Color.ORANGE, fonte2);
            } else if ((tempo.getTotalSecond() > 34) && (tempo.getTotalSecond() <= 41)) {
                janela.drawText("Soon there will be 4, scared?", 210, 580, Color.ORANGE, fonte2);
            } else if ((tempo.getTotalSecond() > 41) && (tempo.getTotalSecond() <= 60)) {
                janela.drawText("There is no way you can beat 4 of them!", 150, 580, Color.ORANGE, fonte2);
            } else if ((tempo.getTotalSecond() > 60) && (tempo.getTotalSecond() <= 75)) {
                janela.drawText("You're making me angry!", 230, 580, Color.ORANGE, fonte2);
            } else if ((tempo.getTotalSecond() > 75) && (tempo.getTotalSecond() <= 85)) {
                janela.drawText("DIE, DIE, DIE!!!", 230, 580, Color.RED, fonte3);
            } else if ((tempo.getTotalSecond() > 85) && (tempo.getTotalSecond() <= 120)) {
                janela.drawText("UNBELIEVEABLE!!!", 180, 580, Color.GREEN, fonte3);
            } else if (tempo.getTotalSecond() > 120) {
                janela.drawText("From now on, it's just luck... You know it", 130, 580, Color.GREEN, fonte2);
            }

            tempo.draw("Time: ");

            nave.draw();

            explosao.draw();

            meteoro.draw();

            meteoro2.draw();

            meteoro3.draw();

            meteoro4.draw();

            meteoro5.draw();

            meteoro6.draw();

            janela.display();


//PARTE REFERENTE AO MOVIMENTO DO JOGADOR --------------------------------------

            if (key_block == false) {
                if (teclado.keyDown(Keyboard.LEFT_KEY)) {
                    nave.moveToLeft();
                    nave.setVelocityX(0.4);
                    nave.setRangeOfFrames(6, 7);

                    nucleo_principal.moveToLeft();
                    nucleo_principal.setVelocityX(0.4);

                } else if (teclado.keyDown(Keyboard.RIGHT_KEY)) {
                    nave.moveToRight();
                    nave.setVelocityX(0.4);
                    nave.setRangeOfFrames(2, 3);

                    nucleo_principal.moveToRight();
                    nucleo_principal.setVelocityX(0.4);
                }

                if (teclado.keyDown(Keyboard.UP_KEY)) {
                    nave.moveToUp();
                    nave.setVelocityY(0.4);
                    nave.setRangeOfFrames(0, 1);

                    nucleo_principal.moveToUp();
                    nucleo_principal.setVelocityY(0.4);
                } else if (teclado.keyDown(Keyboard.DOWN_KEY)) {
                    nave.moveToDown();
                    nave.setVelocityY(0.4);
                    nave.setRangeOfFrames(4, 5);

                    nucleo_principal.moveToDown();
                    nucleo_principal.setVelocityY(0.4);
                }

                if ((teclado.keyDown(Keyboard.UP_KEY)) && (teclado.keyDown(Keyboard.LEFT_KEY))) {
                    nave.setRangeOfFrames(7, 8);
                }
                if ((teclado.keyDown(Keyboard.UP_KEY)) && (teclado.keyDown(Keyboard.RIGHT_KEY))) {
                    nave.setRangeOfFrames(1, 2);
                }
                if ((teclado.keyDown(Keyboard.DOWN_KEY)) && (teclado.keyDown(Keyboard.LEFT_KEY))) {
                    nave.setRangeOfFrames(5, 6);
                }
                if ((teclado.keyDown(Keyboard.DOWN_KEY)) && (teclado.keyDown(Keyboard.RIGHT_KEY))) {
                    nave.setRangeOfFrames(3, 4);
                }
            }

// PARTE REFERENTE AO MOVIMENTO DOS COMETAS ------------------------------------

            // COMETA 1 --------------------------------------------------------

            if (meteoro.x <= 0) {
                direita = true;
            } else if (meteoro.x > 730) {
                direita = false;
            }

            if (direita == true) {
                nucleo1.x += 0.3;
            } else {
                nucleo1.x -= 0.3;
            }


            if (direita == true) {
                meteoro.x += 0.3;
            } else {
                meteoro.x -= 0.3;
            }


            if (meteoro.y <= 0) {
                cima = true;
            } else if (meteoro.y >= 540) {
                cima = false;
            }

            if (cima == true) {
                nucleo1.y += 0.3;
            } else {
                nucleo1.y -= 0.3;
            }

            if (cima == true) {
                meteoro.y += 0.3;
            } else {
                meteoro.y -= 0.3;
            }

            // COMETA 2 --------------------------------------------------------

            if (tempo.getTotalSecond() >= 11) {
                if (meteoro2.x <= 0) {
                    direita2 = true;
                } else if (meteoro2.x > 715) {
                    direita2 = false;
                }

                if (direita2 == true) {
                    nucleo2.x += 0.2;
                } else {
                    nucleo2.x -= 0.2;
                }

                if (direita2 == true) {
                    meteoro2.x += 0.2;
                } else {
                    meteoro2.x -= 0.2;
                }

                if (meteoro2.y <= 0) {
                    cima2 = true;
                } else if (meteoro2.y >= 525) {
                    cima2 = false;
                }

                if (cima2 == true) {
                    nucleo2.y += 0.3;
                } else {
                    nucleo2.y -= 0.3;
                }


                if (cima2 == true) {
                    meteoro2.y += 0.3;
                } else {
                    meteoro2.y -= 0.3;
                }
            }

            // COMETA 3 --------------------------------------------------------

            if (tempo.getTotalSecond() >= 27) {

                if (meteoro3.x <= 0) {
                    direita3 = true;
                } else if (meteoro3.x > 730) {
                    direita3 = false;
                }

                if (direita3 == true) {
                    nucleo3.x += 0.3;
                } else {
                    nucleo3.x -= 0.3;
                }

                if (direita3 == true) {
                    meteoro3.x += 0.3;
                } else {
                    meteoro3.x -= 0.3;
                }

                if (meteoro3.y <= 0) {
                    cima3 = true;
                } else if (meteoro3.y >= 540) {
                    cima3 = false;
                }

                if (cima3 == true) {
                    nucleo3.y += 0.3;
                } else {
                    nucleo3.y -= 0.3;
                }


                if (cima3 == true) {
                    meteoro3.y += 0.3;
                } else {
                    meteoro3.y -= 0.3;
                }
            }

            // COMETA 4 --------------------------------------------------------

            if (tempo.getTotalSecond() >= 41) {
                if (meteoro4.x <= 0) {
                    direita4 = true;
                } else if (meteoro4.x > 700) {
                    direita4 = false;
                }

                if (direita4 == true) {
                    nucleo4.x += 0.2;
                } else {
                    nucleo4.x -= 0.2;
                }

                if (direita4 == true) {
                    meteoro4.x += 0.2;
                } else {
                    meteoro4.x -= 0.2;
                }


                if (meteoro4.y <= 0) {
                    cima4 = true;
                } else if (meteoro4.y >= 510) {
                    cima4 = false;
                }

                if (cima4 == true) {
                    nucleo4.y += 0.2;
                } else {
                    nucleo4.y -= 0.2;
                }

                if (cima4 == true) {
                    meteoro4.y += 0.2;
                } else {
                    meteoro4.y -= 0.2;
                }
            }

            // COMETA 5 --------------------------------------------------------

            if (tempo.getTotalSecond() >= 60) {
                if (meteoro5.x <= 0) {
                    direita5 = true;
                } else if (meteoro5.x > 715) {
                    direita5 = false;
                }

                if (direita5 == true) {
                    nucleo5.x += 0.2;
                } else {
                    nucleo5.x -= 0.2;
                }

                if (direita5 == true) {
                    meteoro5.x += 0.2;
                } else {
                    meteoro5.x -= 0.2;
                }

                if (meteoro5.y <= 0) {
                    cima5 = true;
                } else if (meteoro5.y >= 525) {
                    cima5 = false;
                }

                if (cima5 == true) {
                    nucleo5.y += 0.3;
                } else {
                    nucleo5.y -= 0.3;
                }

                if (cima5 == true) {
                    meteoro5.y += 0.3;
                } else {
                    meteoro5.y -= 0.3;
                }
            }

            // COMETA 6 --------------------------------------------------------

            if (tempo.getTotalSecond() >= 75) {
                if (meteoro6.x <= 0) {
                    direita6 = true;
                } else if (meteoro6.x > 700) {
                    direita6 = false;
                }

                if (direita6 == true) {
                    nucleo6.x += 0.2;
                } else {
                    nucleo6.x -= 0.2;
                }

                if (direita6 == true) {
                    meteoro6.x += 0.2;
                } else {
                    meteoro6.x -= 0.2;
                }

                if (meteoro6.y <= 0) {
                    cima6 = true;
                } else if (meteoro6.y >= 510) {
                    cima6 = false;
                }

                if (cima6 == true) {
                    nucleo6.y += 0.2;
                } else {
                    nucleo6.y -= 0.2;
                }

                if (cima6 == true) {
                    meteoro6.y += 0.2;
                } else {
                    meteoro6.y -= 0.2;
                }
            }


// PARTE REFERENTE A COLISAO ---------------------------------------------------

            colisao = (Collision.collided(nucleo_principal, nucleo1))
                    || (Collision.collided(nucleo_principal, nucleo2))
                    || (Collision.collided(nucleo_principal, nucleo3))
                    || (Collision.collided(nucleo_principal, nucleo4))
                    || (Collision.collided(nucleo_principal, nucleo5))
                    || (Collision.collided(nucleo_principal, nucleo6));

            if (colisao) {
                {
                    nave.hide();
                    nucleo_principal.hide();
                    key_block = true;
                    gameover = true;
                }
            }

// PARTE REFERENTE AO FIM DE JOGO ----------------------------------------------

            if (gameover == true) {
                explosao.setPosition(nucleo_principal.x - 20, nucleo_principal.y - 20);
                explosao.runAnimation();
                explosao.setTimeChangeFrame(20);
                explosao.setRepeatAnimation(false);
            }

            if ((explosao.isAnimationFinished() == true) && (gameover == true)) {
                gameover = false;
                explosao.hide();
                explosao.reset();
                nave.unhide();
                nucleo_principal.unhide();
                executando = false;
                JOptionPane.showMessageDialog(null, "Colidiu com o meteoro! \n" + "Seu tempo foi: " + tempo);
                musica.stop();
                musica2.play();
                menu = true;
            }

// PARTE RELATIVA A TELA DE FIM DE JOGO ----------------------------------------

            while ((menu == true) && (executando == false)) {
                fundo2.draw();

                teclado.releaseKeys();

                gameover = false;

                tempo.setTime(00, 00, 00);

                janela.drawText("GAME OVER", 180, 100, Color.GREEN, fonte6);
                janela.drawText("Press ENTER to RETRY", 45, 550, Color.GREEN, fonte5);
                janela.drawText("Or esc to RUN AWAY", 100, 580, Color.RED, fonte5);

                explosao.setPosition(-200, -200);
                explosao.unhide();

                nave.x = 400;
                nave.y = 300;

                nucleo_principal.x = 410;
                nucleo_principal.y = 300;

                meteoro.x = 0;
                meteoro.y = 0;

                meteoro2.x = 801;
                meteoro2.y = 601;

                meteoro3.x = 801;
                meteoro3.y = -60;

                meteoro4.x = -60;
                meteoro4.y = 601;

                meteoro5.x = -80;
                meteoro5.y = -80;

                meteoro6.x = 801;
                meteoro6.y = 601;

                nucleo1.x = meteoro.x + 10;
                nucleo1.y = meteoro.y + 10;

                nucleo2.x = meteoro2.x + 18;
                nucleo2.y = meteoro2.y + 18;

                nucleo3.x = meteoro3.x + 10;
                nucleo3.y = meteoro3.y + 10;

                nucleo4.x = meteoro4.x + 23;
                nucleo4.y = meteoro4.y + 25;

                nucleo5.x = meteoro5.x + 18;
                nucleo5.y = meteoro5.y + 18;

                nucleo6.x = meteoro6.x + 23;
                nucleo6.y = meteoro6.y + 25;

                janela.display();

                if (teclado.keyDown(Keyboard.ENTER_KEY)) {
                    musica2.stop();
                    musica.play();
                    key_block = false;
                    menu = false;
                    executando = true;
                } else if (teclado.keyDown(Keyboard.ESCAPE_KEY)) {
                    janela.exit();
                }

            }


            if (teclado.keyDown(Keyboard.ESCAPE_KEY)) {
                janela.exit();
            }
        }

        janela.exit();
    }
}
